//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_AddNewDialog.h"
#include "App_PresetsDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppAddNewDialog* AppAddNewDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == OkButton->ModalResult) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::PresetsButtonClick(TObject* ASender)
{
	TAppPresetsDialog::EnsureCreated();
	if(!AppPresetsDialog->Execute()) {
		Abort();
	}
	Inputs = AppPresetsDialog->Values;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::ComboBox11Exit(TObject* ASender)
{
	InputInComboBox11;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::Edit21Exit(TObject* ASender)
{
	InputInEdit21;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::Edit22Exit(TObject* ASender)
{
	InputInEdit22;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::Edit23Exit(TObject* ASender)
{
	InputInEdit23;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::Edit24Exit(TObject* ASender)
{
	InputInEdit24;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::Initialize()
{
	try {
		TDiskImageSpec LValues;
		LValues.DiskType = TDiskImage::DiskType_2d;
		LValues.C = 40;
		LValues.H = 2;
		LValues.R = 16;
		LValues.N = 1;
		FValues = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::HandleInvalidInput(const AnsiString& AMessage, TWinControl* AControl)
{
	if(AControl != NULL && AControl->Enabled && AControl->Visible) {
		ActiveControl = AControl;
	}
	else {
		ActiveControl = NULL;
	}
	throw EInvalidOperation(AMessage);
}
//---------------------------------------------------------------------------
TDiskImageSpec __fastcall TAppAddNewDialog::GetInputs()
{
	TDiskImageSpec LInputs;
	LInputs.DiskType = InputInComboBox11;
	LInputs.C = InputInEdit21;
	LInputs.H = InputInEdit22;
	LInputs.R = InputInEdit23;
	LInputs.N = InputInEdit24;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::SetInputs(const TDiskImageSpec& AInputs)
{
	InputInComboBox11 = AInputs.DiskType;
	InputInEdit21 = AInputs.C;
	InputInEdit22 = AInputs.H;
	InputInEdit23 = AInputs.R;
	InputInEdit24 = AInputs.N;
}
//---------------------------------------------------------------------------
int __fastcall TAppAddNewDialog::GetInputInComboBox11()
{
	int LInput = -1;
	switch(ComboBox11->ItemIndex) {
	case 0:
		LInput = TDiskImage::DiskType_2d;
		break;
	case 1:
		LInput = TDiskImage::DiskType_2dd;
		break;
	case 2:
		LInput = TDiskImage::DiskType_2hd;
		break;
	default:
		HandleInvalidInput("Specify the disk type.", ComboBox11);
		break;
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::SetInputInComboBox11(int AInput)
{
	int LIndex = -1;
	switch(AInput) {
	case TDiskImage::DiskType_2d:
		LIndex = 0;
		break;
	case TDiskImage::DiskType_2dd:
		LIndex = 1;
		break;
	case TDiskImage::DiskType_2hd:
		LIndex = 2;
		break;
	default:
		HandleInvalidInput("The program does not support the disk type.", NULL);
		break;
	}
	ComboBox11->ItemIndex = LIndex;
}
//---------------------------------------------------------------------------
int __fastcall TAppAddNewDialog::GetInputInEdit21()
{
	int LInput;
	if(!TryStrToInt(Edit21->Text, LInput) || LInput < 0 || LInput > TDiskImage::MaxC) {
		HandleInvalidInput("The program cannot accept the C value.", Edit21);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::SetInputInEdit21(int AInput)
{
	Edit21->Text = AInput;
}
//---------------------------------------------------------------------------
int __fastcall TAppAddNewDialog::GetInputInEdit22()
{
	int LInput;
	if(!TryStrToInt(Edit22->Text, LInput) || LInput < 0 || LInput > TDiskImage::MaxH) {
		HandleInvalidInput("The program cannot accept the H value.", Edit22);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::SetInputInEdit22(int AInput)
{
	Edit22->Text = AInput;
}
//---------------------------------------------------------------------------
int __fastcall TAppAddNewDialog::GetInputInEdit23()
{
	int LInput;
	if(!TryStrToInt(Edit23->Text, LInput) || LInput < 0 || LInput > TDiskImage::MaxR) {
		HandleInvalidInput("The program cannot accept the R value.", Edit23);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::SetInputInEdit23(int AInput)
{
	Edit23->Text = AInput;
}
//---------------------------------------------------------------------------
int __fastcall TAppAddNewDialog::GetInputInEdit24()
{
	int LInput;
	if(!TryStrToInt(Edit24->Text, LInput) || LInput < 0 || LInput > TDiskImage::MaxN) {
		HandleInvalidInput("The program cannot accept the N value.", Edit24);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::SetInputInEdit24(int AInput)
{
	Edit24->Text = AInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::DoShow()
{
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::DoHide()
{
	ActiveControl = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppAddNewDialog::EnsureCreated()
{
	if(AppAddNewDialog != NULL) {
		return;
	}
	AppAddNewDialog = new TAppAddNewDialog(Application);
}
//---------------------------------------------------------------------------
__fastcall TAppAddNewDialog::TAppAddNewDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppAddNewDialog::~TAppAddNewDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TAppAddNewDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == OkButton->ModalResult;
}
//---------------------------------------------------------------------------

