//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_Handler.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_handler {
//---------------------------------------------------------------------------
void __fastcall THandler::HandleFeatureUnavailable()
{
	throw EHandlerError("The feature is unavailable.");
}
//---------------------------------------------------------------------------
void __fastcall THandler::DoChange()
{
	if(OnChange != NULL) {
		OnChange(this);
	}
}
//---------------------------------------------------------------------------
__fastcall THandler::THandler() :
	TObject(),
	FChangeCount(0),
	FOnChange(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THandler::~THandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THandler::Change()
{
	if(ChangeCount != 0) {
		return;
	}
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall THandler::BeginChange()
{
	++FChangeCount;
}
//---------------------------------------------------------------------------
void __fastcall THandler::EndChange()
{
	if(ChangeCount == 0) {
		throw EHandlerError("The program cannot end any change operations.");
	}
	--FChangeCount;
	Change();
}
//---------------------------------------------------------------------------
} // End namespace App_handler
//---------------------------------------------------------------------------

