//---------------------------------------------------------------------------
#ifndef App_HandlerH
#define App_HandlerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
namespace App_handler {
//---------------------------------------------------------------------------
class EHandlerError : public Exception
{
public:
	__fastcall EHandlerError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class THandler : public TObject
{
private:
	int FChangeCount;
	TNotifyEvent FOnChange;
	__property int ChangeCount = {read=FChangeCount};
protected:
	virtual void __fastcall HandleFeatureUnavailable();
	virtual void __fastcall DoChange();
public:
	__fastcall THandler();
	virtual __fastcall ~THandler();
	virtual void __fastcall Change();
	virtual void __fastcall BeginChange();
	virtual void __fastcall EndChange();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile) = 0;
	virtual void __fastcall SaveSettings(TMemIniFile* AFile) = 0;
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
} // End namespace App_handler
using namespace App_handler;
//---------------------------------------------------------------------------
#endif

