//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_HelpHandler.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_helphandler {
//---------------------------------------------------------------------------
const AnsiString THelpHandler::HelpPath =
	ExtractFilePath(Application->ExeName) +
	"Help\\index.html";
const AnsiString THelpHandler::About =
	"D88 Edit Version 1.0.1\r\n"
	"\r\n"
	"Copyright (C) 2011-2012 Moochos. All rights reserved.";
//---------------------------------------------------------------------------
__fastcall THelpHandler::THelpHandler() :
	THandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpHandler::~THelpHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowContents()
{
	if(!CanShowContents()) {
		HandleFeatureUnavailable();
	}
	if(Application->MessageBox(
		"The program opens the help (a local file in the HTML format).",
		Application->Title.c_str(),
		MB_OKCANCEL | MB_ICONWARNING | MB_SETFOREGROUND) != IDOK) {
		Abort();
	}
	SHELLEXECUTEINFO LInfo = {0};
	LInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	LInfo.fMask = SEE_MASK_FLAG_NO_UI;
	LInfo.lpVerb = "open";
	LInfo.lpFile = HelpPath.c_str();
	LInfo.nShow = SW_SHOW;
	if(!ShellExecuteEx(&LInfo)) {
		throw EHandlerError("The program could not open the help.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall THelpHandler::CanShowContents()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowAbout()
{
	if(!CanShowAbout()) {
		HandleFeatureUnavailable();
	}
	Application->MessageBox(
		About.c_str(),
		"About",
		MB_OK | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
bool __fastcall THelpHandler::CanShowAbout()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::LoadSettings(TMemIniFile* AFile)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::SaveSettings(TMemIniFile* AFile)
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace App_helphandler
//---------------------------------------------------------------------------

