//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_SettingsHandler.h"
#include "Moa_AutoPointers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_settingshandler {
//---------------------------------------------------------------------------
const AnsiString TSettingsHandler::SettingsPath = ExtractFilePath(Application->ExeName) + "Settings.ini";
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::Initialize()
{
	try {
		FHandlers = new TList();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::Uninitialize()
{
	delete FHandlers;
	FHandlers = NULL;
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandler::TSettingsHandler() :
	THandler(),
	FHandlers(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandler::~TSettingsHandler()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::Load()
{
	if(!CanLoad()) {
		HandleFeatureUnavailable();
	}
	if(!FileExists(SettingsPath)) {
		return;
	}
	TAutoPointer<TMemIniFile> LFile;
	try {
		LFile = new TMemIniFile(SettingsPath);
		for(int LI = 0; LI < Handlers->Count; ++LI) {
			static_cast<THandler*>(Handlers->Items[LI])->LoadSettings(LFile);
		}
	}
	catch(EIniFileException& LException) {
		throw EHandlerError("The program could not load the settings.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TSettingsHandler::CanLoad()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::Save()
{
	if(!CanSave()) {
		HandleFeatureUnavailable();
	}
	TAutoPointer<TMemIniFile> LFile;
	try {
		LFile = new TMemIniFile(SettingsPath);
		for(int LI = 0; LI < Handlers->Count; ++LI) {
			static_cast<THandler*>(Handlers->Items[LI])->SaveSettings(LFile);
		}
		LFile->UpdateFile();
	}
	catch(EIniFileException& LException) {
		throw EHandlerError("The program could not save the settings.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TSettingsHandler::CanSave()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::LoadSettings(TMemIniFile* AFile)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::SaveSettings(TMemIniFile* AFile)
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // namespace App_settingshandler
//---------------------------------------------------------------------------

