//---------------------------------------------------------------------------
#ifndef Moa_FileDropH
#define Moa_FileDropH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-08-29 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_filedrop {
//---------------------------------------------------------------------------
class EFileDropError : public Exception
{
public:
	__fastcall EFileDropError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TDroppedFiles : public TObject
{
private:
	HDROP FHandle;
	void __fastcall Initialize(HDROP AHandle);
	void __fastcall Uninitialize();
	AnsiString __fastcall GetFile(int AIndex);
	int __fastcall GetCount();
	TPoint __fastcall GetPoint();
protected:
public:
	__fastcall TDroppedFiles(HDROP AHandle);
	virtual __fastcall ~TDroppedFiles();
	virtual void __fastcall Finish();
	virtual bool __fastcall IsFinished();
	__property HDROP Handle = {read=FHandle};
	__property AnsiString Files[int AIndex] = {read=GetFile};
	__property int Count = {read=GetCount};
	__property TPoint Point = {read=GetPoint};
};
//---------------------------------------------------------------------------
typedef void __fastcall (__closure * TFileDropEvent)(TObject* ASender, TDroppedFiles* AFiles, bool& AHandled);
//---------------------------------------------------------------------------
class TFileDropWatcher : public TObject
{
private:
	TControl* FControl;
	TWndMethod FOldHandleMessage;
	bool FEnabled;
	TFileDropEvent FOnDrop;
	void __fastcall Attach(TControl* AControl);
	void __fastcall Detach();
	void __fastcall HandleMessage(TMessage& AMessage);
	bool __fastcall HandleWmDropFiles(TMessage& AMessage);
	void __fastcall SetControl(TControl* AControl);
	void __fastcall SetEnabled(bool AEnabled);
	__property TWndMethod OldHandleMessage = {read=FOldHandleMessage};
protected:
	virtual bool __fastcall DoDrop(TDroppedFiles* AFiles);
public:
	__fastcall TFileDropWatcher(TControl* AControl = NULL);
	virtual __fastcall ~TFileDropWatcher();
	__property TControl* Control = {read=FControl, write=SetControl};
	__property bool Enabled = {read=FEnabled, write=SetEnabled};
	__property TFileDropEvent OnDrop = {read=FOnDrop, write=FOnDrop};
};
//---------------------------------------------------------------------------
} // End namespace Moa_filedrop
using namespace Moa_filedrop;
//---------------------------------------------------------------------------
#endif

